﻿# -*- coding: UTF-8 -*-
import os, sys, threading, re, platform
import prep_files as p_files
import prep_geocode as p_geocode

from kivy.app import App
from kivy.uix.screenmanager import ScreenManager, Screen, FadeTransition
from kivy.uix.boxlayout import BoxLayout
from kivy.uix.floatlayout import FloatLayout
from kivy.uix.checkbox import CheckBox
from kivy.uix.button import Button
from kivy.uix.popup import Popup
from kivy.properties import ObjectProperty
from kivy.lang import Builder

from kivy.uix.recycleview import RecycleView
from kivy.uix.recycleview.views import RecycleDataViewBehavior
from kivy.uix.label import Label
from kivy.properties import BooleanProperty
from kivy.uix.recycleboxlayout import RecycleBoxLayout
from kivy.uix.recyclegridlayout import RecycleGridLayout
from kivy.uix.behaviors import FocusBehavior
from kivy.uix.recycleview.layout import LayoutSelectionBehavior

from kivy.uix.behaviors import ButtonBehavior

from kivy.factory import Factory

# Força a aplicação a não iniciar em tela cheia
from kivy.config import Config
Config.set('graphics', 'fullscreen', '0')
# Correção do erro: 'Kivy Minimum required OpenGL version (2.0) NOT found'
Config.set('graphics', 'multisamples', '0')

from kivy.utils import get_color_from_hex
from kivy.core.window import Window
# Window.clearcolor = [1, 1, 1, 1]
Window.clearcolor = get_color_from_hex('#dfdfdf')
# Window.clearcolor = get_color_from_hex('#00bbb5')
# Window.size = 600, 700
Window.size = 600, 500

# --------------------------------------------------------
# Variáveis e funções globais
arquivo = ''
delimitador = ''
dados_arquivo_original = []
colunas_arquivo_original = []
colunas_selecionadas = []
recycleview_data = []
registros_por_arquivo = 0

def indexScreen(name_screen):
    list_screens = App.get_running_app().root.screen_names
    index_screen = list_screens.index(name_screen)
    return index_screen
# --------------------------------------------------------

class MyCheckBox(CheckBox):
    pass

class LoadDialog(FloatLayout):
    load = ObjectProperty(None)
    cancel = ObjectProperty(None)

class Arquivo(Screen):

    def dismiss_popup(self):
        self._popup.dismiss()

    def show_load(self):
        content = LoadDialog(load=self.load, cancel=self.dismiss_popup)
        self._popup = Popup(title="Selecionar Arquivo", content=content,
                            size_hint=(0.9, 0.9))
        self._popup.open()

    def load(self, path, filename):
        if filename:
            global arquivo
            arquivo = os.path.join(path, filename[0])
            self.ids.lb_nome_arquivo.text = arquivo
            self.ids.btnNextArquivo.disabled = False
        self.dismiss_popup()

    def manipula_arquivo(self):
        d = self.ids.text_input_delimitador.text
        global delimitador
        delimitador = ';' if d=='' else d[0]

        global arquivo, dados_arquivo_original, colunas_arquivo_original
        if arquivo != '':
            dct = p_files.lista_colunas(arquivo, delimitador)
            dados_arquivo_original = dct['linhas']
            colunas_arquivo_original = dct['headers']
        else:
            self.ids.btnNextArquivo.disabled = True

    def populate_cols(self):
        importedlist = colunas_arquivo_original[:]

        index_screen = indexScreen('colunas')
        for name in importedlist:
            NameLabel = ButtonLabel(text=(name))
            App.get_running_app().root.screens[index_screen].ids.deselected_list.ids.content.add_widget(NameLabel)

class Colunas(Screen):
    # pass
    def reboot(self):
        global delimitador, dados_arquivo_original, colunas_arquivo_original, colunas_selecionadas, recycleview_data, registros_por_arquivo
        delimitador = ''
        dados_arquivo_original = []
        colunas_arquivo_original = []
        colunas_selecionadas = []
        recycleview_data = []
        registros_por_arquivo = 0
        self.ids.selected_list.ids.content.clear_widgets()
        self.ids.deselected_list.ids.content.clear_widgets()
        self.ids.btnNextColunas.disabled = True


class Filtro(Screen):
    def populate_spinner(self):
        spinner_coluna_val = colunas_arquivo_original[:]
        spinner_coluna_val.insert(0, '<Selecione>')
        self.ids.spinner_coluna.values = tuple(spinner_coluna_val)

    def populate_spinner_val(self):
        coluna = self.ids.spinner_coluna.text
        valores = []
        if coluna in colunas_arquivo_original:
            for d in dados_arquivo_original:
                valores.append(d[coluna])
            valores_unicos = list(set(valores))
            tpl_val = (str(len(valores_unicos)) + ' valores possíveis.',)
            valores_unicos.insert(0, '<Selecione>')
            self.ids.spinner_valor.values = tuple(valores_unicos) if len(valores_unicos)<=100 else tpl_val
        else:
            self.ids.spinner_valor.values = tuple()

    def msg_filtro(self):
        if (self.ids.spinner_coluna.text == '<Selecione>') or \
           (self.ids.spinner_valor.text == '<Selecione>'):
            self.ids.msg.text = 'O filtro informado será ignorado.'
        else:
            self.ids.msg.text = ''

    def filtra_dados(self):
        filtro_coluna = self.ids.spinner_coluna.text
        filtro_valor = self.ids.spinner_valor.text
        if (filtro_coluna != '<Selecione>' and filtro_valor != '<Selecione>'):
            global dados_arquivo_original
            dados = dados_arquivo_original[:]
            for i in dados:
                if i[filtro_coluna] != filtro_valor:
                    dados_arquivo_original.remove(i)
            if len(dados_arquivo_original)==0:
                msg = 'Nenhum registro encontrado para o filtro especificado.\nO filtro será ignorado.'
                dados_arquivo_original = dados[:]
                self.pop_up = Factory.PopupProgress()
                self.pop_up.update_pop_up_text(msg)
                self.pop_up.open()

class RegistrosPorArquivo(Screen):

    def formata_num_r_p_a(self, rpa, tam):
        r_p_a = 0
        if rpa == 'Todos' or rpa == '':
            r_p_a = int(tam)
        else:
            r_p_a = int(re.sub('[^0-9]', '', rpa))
        return r_p_a

    def define_qtd_registros_por_arquivo(self):
        global registros_por_arquivo
        rpa = ''
        for i in recycleview_data:
            if i in ['10', '100', '1 000', '10 000', 'Todos']:
                rpa = i
                break
        registros_por_arquivo = self.formata_num_r_p_a(rpa, len(dados_arquivo_original))

class Servico(Screen):

    def show_popup(self, msg):
        self.pop_up = Factory.PopupProgress()
        self.pop_up.update_pop_up_text(msg)
        self.pop_up.open()

    def process_button_click(self):
        geocode_service = self.ids.text_input_geo_servico.text
        http_code = p_geocode.testa_conexao(geocode_service)
        if http_code == 200:
            self.show_popup('Aguarde o fim do processamento...')
            mythread = threading.Thread(target=self.inicia_processamento)
            mythread.start()
        else:
            self.show_popup('Verifique a URL do serviço de geocodificação.')

    def inicia_processamento(self):
        geocode_service = self.ids.text_input_geo_servico.text
        colunas = colunas_selecionadas[:]
        dados_preparados = p_files.prepara_dados(dados_arquivo_original, colunas)
        dados_padronizados = p_files.padroniza_dados(dados_preparados)

        p_files.gera_arquivo(dados_arquivo_original, 'original', arquivo, colunas_arquivo_original)

        labels_arquivo_geocode = ['KEY', 'COLUNA_PESQ', 'DADO_COMPL_PESQ', 'DADO_PESQ', 'LOCAL_ENCONTRADO', 'SIMILARIDADE', 'LAT', 'LONG']

        global registros_por_arquivo
        fatias = list( p_geocode.fatia_lista(dados_padronizados, registros_por_arquivo) )
        val = 0
        for v in fatias:
            val += 1

            dct_pesquisa = 	{'prioridade': colunas, 'dados': v, 'geocode_service': geocode_service}
            lista_final = self.gera_lista_final(dct_pesquisa)

            p_files.gera_arquivo(lista_final, 'geocode' + str(val), arquivo, labels_arquivo_geocode)

        self.lista_arquivos_gerados()

        self.pop_up.dismiss()

    def gera_lista_final(self, dct_pesquisa):
        '''
        Recebe dicionário com dados do arquivo csv (lista de dicionários com a chave e com as colunas a serem geocodificadas) e lista de colunas na ordem que deve ser feita a geocodificação.
        Monta a lista final que será gravada em novo arquivo csv aplicando a função _consulta_geocode para cada registro.
        '''
        try:
            dados = dct_pesquisa['dados']
            colunas = dct_pesquisa['prioridade']
            geocode_service = dct_pesquisa['geocode_service']

            dados_finais = []
            total = len(dados)
            ct = 1

            for d in dados:

                lb_key = 'KEY'
                key = d[lb_key]

                dct = {lb_key: key}

                for c in colunas:
                    if c in list(d.keys()):
                        result_set = p_geocode._consulta_geocode(d[c], c, geocode_service)
                        dct.update(result_set)
                        if dct['SIMILARIDADE']!=0.0:
                            break

                dados_finais.append(dct)

                self.pop_up.update_pop_up_text(str(ct) + ' de ' + str(total))

                sys.stdout.write('\r{0} de {1}'.format(ct, total))
                sys.stdout.flush ()
                ct += 1
            print('\n')

            return dados_finais
        except Exception as e:
            print ('Erro ao gerar lista final: %s' % e)

    def lista_arquivos_gerados(self):
        try:
            separador = '\\' if platform.system() == 'Windows' else '/'
            dct = p_files._identifica_diretorio(arquivo)
            diretorio = dct['diretorio']
            nome_arquivo = dct['nome_arquivo']
            diretorio_saida = diretorio + 'files_' + nome_arquivo.replace('.csv', '') + separador

            if os.path.exists(diretorio_saida):
                lista_arquivos = os.listdir(diretorio_saida)
                lista_arquivos_ordenada = sorted(lista_arquivos)

                index_screen = indexScreen('final')
                text_label = 'Arquivos gerados:\n\t' + diretorio_saida

                for i in lista_arquivos_ordenada:
                    text_label += ('\n\t\t' + i)

                App.get_running_app().root.screens[index_screen].ids.text_input_diretorio.text = text_label
            else:
                text_label = 'Houve um problema ao acessar o diretório de saída. Verifique se novos arquivos foram gerados no diretório do arquivo csv original.'
                App.get_running_app().root.screens[index_screen].ids.text_input_diretorio.text = text_label
        except Exception as e:
            text_label = 'Verifique se novos arquivos foram gerados no diretório do arquivo csv original.'
            App.get_running_app().root.screens[index_screen].ids.text_input_diretorio.text = text_label

class Final(Screen):
    pass

class ScreenManagement(ScreenManager):
    pass

class PopupProgress(Popup):
    pop_up_text = ObjectProperty()
    def update_pop_up_text(self, p_message):
        self.pop_up_text.text = p_message

class RecycleBoxLayoutSelecionavel(FocusBehavior, LayoutSelectionBehavior, RecycleBoxLayout):
    ''' Adiciona seleção e comportamento de foco à exibição '''
    pass

class LabelSelecionavel(RecycleDataViewBehavior, Label):
    ''' Adiciona suporte de seleção ao componente Label '''
    index = None
    selected = BooleanProperty(False)
    selectable = BooleanProperty(True)

    def refresh_view_attrs(self, rv, index, data):
        ''' Captura e manipula alterações na exibição '''
        self.index = index
        return super(LabelSelecionavel, self).refresh_view_attrs(rv, index, data)

    def on_touch_down(self, touch):
        ''' Adiciona seleção ao ser pressionado '''
        if super(LabelSelecionavel, self).on_touch_down(touch):
            return True
        if self.collide_point(*touch.pos) and self.selectable:
            return self.parent.select_with_touch(self.index, touch)

    def apply_selection(self, rv, index, is_selected):
        ''' Responde à seleção de itens na exibição '''
        self.selected = is_selected
        if is_selected:
            if rv.data[index]['text'] not in recycleview_data:
                recycleview_data.append(rv.data[index]['text'])
        else:
            if rv.data[index]['text'] in recycleview_data:
                recycleview_data.remove(rv.data[index]['text'])

class ButtonLabel(ButtonBehavior, Label):
    @property
    def selected_list_content(self):
        index_screen = indexScreen('colunas')
        return App.get_running_app().root.screens[index_screen].ids.selected_list.ids.content

    @property
    def deselected_list_content(self):
        index_screen = indexScreen('colunas')
        return App.get_running_app().root.screens[index_screen].ids.deselected_list.ids.content

    def change_location(self):
        try:
            if self.parent == self.deselected_list_content:
                if len(colunas_selecionadas) in range(0, 4):
                    self.parent.remove_widget(self)
                    self.selected_list_content.add_widget(self)
                    colunas_selecionadas.append(self.text)
                    if len(colunas_selecionadas) != 0:
                        index_screen = indexScreen('colunas')
                        App.get_running_app().root.screens[index_screen].ids.btnNextColunas.disabled = False
            else:
                self.parent.remove_widget(self)
                self.deselected_list_content.add_widget(self)
                colunas_selecionadas.remove(self.text)
                if len(colunas_selecionadas) == 0:
                    index_screen = indexScreen('colunas')
                    App.get_running_app().root.screens[index_screen].ids.btnNextColunas.disabled = True
        except Exception as e:
            print(e)

class CustomRecycleView(RecycleView):
    pass

class MainApp(App):
    pass

main_app = MainApp()
main_app.title = 'Geocode CSV'
main_app.icon = 'geocode.png'

if __name__ == '__main__':
    main_app.run()
